﻿--[[
	Author: Darcey@AllForTheCode.co.uk
--]]

local mapSetToCurrentZoneRunOnce = false;
local t = 0;
local tMax = 10;
local oldValue = "";

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- initFunctions
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

--


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- eventHandlerFunctions
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
local uip = _G["UIParent"]

DCoordsMainFrameUpdateHandler = function()	
	
	-- Prevent update at full FPS
	t = t+1;
	if (t>tMax) then
		--log("DCoords update run");
		t = 0;
	else
		return;
	end
	

	-- UIParent HideUI with ALT-Z Detection
	-- Addon gets obscured by other addons when using UIParent
	--[[
	local uipv = uip:IsVisible();
	log(GetTime());
	log("uipv = " .. tostring(uipv));
	log("DCoords_MainFrameVisible = " .. tostring(DCoords_MainFrameVisible));
	if (uip:IsVisible() == false) then
		DCoordsMainFrame:Hide();
		return;
	elseif (uip:IsVisible() == true and DCoords_MainFrameVisible == true) then
		log("SHOW");
		DCoordsMainFrame:Show();
	end
	--]]	
	


    --log("DCoordsMainFrameUpdateHandler()");
	
	-- Just encase
	if (mapSetToCurrentZoneRunOnce == false) then
		SetMapToCurrentZone();
		mapSetToCurrentZoneRunOnce = true;
	end
	
	px, py = GetPlayerMapPosition("player");
	
	local precision = "%."..DCoords_MainFrameDecimalPrecision.."f";
	px = string.format(precision, (px*100));
	py = string.format(precision, (py*100));
		
	zone = "";
	subZone = "";
	
	if (DCoords_MainFrameShowZone==true) then
		zone = GetZoneText();
	else
		zone = "";
	end
	
	if (DCoords_MainFrameShowSubZone==true) then
		subZone = GetSubZoneText();
	else
		subZone = "";
	end	
	
	if (zone == "") and (subZone == "") then
		location = px .. " - " .. py;
	elseif (zone ~= "") and (subZone == "") then
		location = zone .. " - " .. px  .. " : " .. py;
	elseif (zone == "") and (subZone ~= "") then
		location = subZone .. " - " .. px .. " : " .. py;
	elseif (zone ~= "") and (subZone ~= "") then
		if (zone == subZone) then
			location = zone .. " - " .. px  .. " : " .. py;
		else
			location = zone .. " - " .. subZone .. " - " .. px .. " : " .. py;
		end
	else
		location = "Darcey@AllForTheCode.co.uk";
	end

	location = " " .. location .. " ";

	setDCoordsMainFrameText(location);
	
	
	-- NOTE DO NOT SET HEIGHT HERE
	local txtW = DCoordsMainFrameText:GetStringWidth();
	DCoordsMainFrame:SetWidth(txtW);
	--DCoordsMainFrame:SetPoint("BOTTOMLEFT",DCoords_MainFrameX,DCoords_MainFrameY);
	
	
	if (DCoords_MapFrameVisible == true) then
		updateMapCoordinate();
	end
	
end






function updateMapCoordinate()

	if (WorldMapFrame:IsVisible()) then
		
		--[[
		local mouseIsOver = GetMouseFocus():GetName();
		if (mouseIsOver == "WorldFrame" or mouseIsOver == "QuestMapFrame") then
			return
		end
		--]]
			

		-- World map calc
		local mapscale = WorldMapDetailFrame:GetEffectiveScale();
		local cursorX, cursorY = GetCursorPosition();
		cursorX = cursorX / mapscale;
		cursorY = cursorY / mapscale;
		local width = WorldMapDetailFrame:GetWidth();
		local height = WorldMapDetailFrame:GetHeight();
		local left = WorldMapDetailFrame:GetLeft();
		local top = WorldMapDetailFrame:GetTop();
		
		cursorX = (cursorX - left) / width * 100;
		cursorY = (top - cursorY) / height * 100;
		
		local cx, cy;
		if (DCoords_MainFrameDecimalPrecision==3) then
			cx = format("%.3f",cursorX);
			cy = format("%.3f",cursorY);
		elseif (DCoords_MainFrameDecimalPrecision==2) then
			cx = format("%.2f",cursorX);
			cy = format("%.2f",cursorY);
		elseif (DCoords_MainFrameDecimalPrecision==1) then
			cx = format("%.1f",cursorX);
			cy = format("%.1f",cursorY);
		else
			cx = floor(cursorX);
			cy = floor(cursorY);
		end

		
		--Coordinates_worldMapText:SetText("You: [" .. playerX .. " - " .. playerY .. "]     " .. DCoordsMapTextLabel);
		
		Coordinates_worldMapText:SetText("You " .. px .. "," .. py .. "   Cursor " .. cx .. "," .. cy);
		--log(DCoordsMapTextLabel);
		--log(mouseIsOverMap);
		--log( GetMouseFocus():GetName() );
		
		
	end
	
	
	
end



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- init/constructor
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

--
