﻿--[[
	Author: Darcey@AllForTheCode.co.uk
--]]


-- var def/init
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- initFunctions
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function initDCoordsMenuFrame()
      log("initDCoordsMenuFrame()");

      DCoordsMenuFrame = CreateFrame("frame","DCoordsMenuFrame5566221")
      DCoordsMenuFrame:SetBackdrop({
            bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
            edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
            tile=1, tileSize=32, edgeSize=32, 
            insets={left=11, right=12, top=12, bottom=11}
      })
      DCoordsMenuFrame:SetWidth(780)
      DCoordsMenuFrame:SetHeight(380)
      DCoordsMenuFrame:EnableMouse(true)
      DCoordsMenuFrame:SetMovable(true)
      DCoordsMenuFrame:SetPoint("CENTER",UIParent,0,0)
      DCoordsMenuFrame:RegisterForDrag("LeftButton")
      DCoordsMenuFrame:SetScript("OnDragStart", function(self) self:StartMoving() end)
      DCoordsMenuFrame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
      DCoordsMenuFrame:SetFrameStrata("FULLSCREEN_DIALOG")
      DCoordsMenuFrame:SetScale(0.9);
      DCoordsMenuFrame:Hide();

      -- Frame titles
      local DCoordsMenuFrame_Title1 = createText(DCoordsMenuFrame,"DCoords v"..DCoordsVersion,20,15,-11);
      local DCoordsMenuFrame_Title2 = createText(DCoordsMenuFrame,"Darcey@AllForTheCode.co.uk",9,15.5,-29);
      
      -- Checkboxes
      -- function createCheckbox(frame,id,label,size,x,y)
      local cbY = -46;
      local cbInc = 26;
      cbShowDCoords = createCheckbox(DCoordsMenuFrame,"cbShowDCoords","Show DCoords",12,18,cbY,"cbShowDCoordsHandler");
      cbY = cbY - cbInc;
      cbEnableDrag = createCheckbox(DCoordsMenuFrame,"cbEnableDrag","Enable left click drag",12,18,cbY,"cbEnableDragHandler");
      cbY = cbY - cbInc;
      cbShowZone = createCheckbox(DCoordsMenuFrame,"cbShowZone","Show zone",12,18,cbY,"cbShowZoneHandler");
      cbY = cbY - cbInc;
      cbShowSubZone = createCheckbox(DCoordsMenuFrame,"cbShowSubZone","Show sub zone",12,18,cbY,"cbShowSubZoneHandler");
      cbY = cbY - cbInc;
      cbShowBackground = createCheckbox(DCoordsMenuFrame,"cbShowBackground","Show background",12,18,cbY,"cbShowBackgroundHandler");
      cbY = cbY - cbInc;
      cbShowMapCoordinates = createCheckbox(DCoordsMenuFrame,"cbShowMapCoordinates","Show map coordinates",12,18,cbY,"cbShowMapCoordinatesHandler");
      cbY = cbY - cbInc;

      -- Sliders
      --local SetMainFrameTextColorLabel = createText(DCoordsMenuFrame,"Coordinates font color (R,G,B White is 1|1|1)",12,156,-40);
      --local s1 = createSlider(frame,id,x,y,min,max,default,label,width)
      local pY = -48;
      local pInc = 40;
      sliderDecimalPrecision = createSlider(DCoordsMenuFrame,"sliderDecimalPrecision",160,pY,0,3,1,"Decimal places to display",160,"sliderDecimalPrecisionChangeHandler");
      sliderDecimalPrecision:SetValueStep(1);
      pY = pY - pInc;
      sliderTextR = createSlider(DCoordsMenuFrame,"sliderTextR",160,pY,0,1,1,"Coordinates font color Red (R)",160,"sliderRChangeHandler");
      pY = pY - pInc;
      sliderTextG = createSlider(DCoordsMenuFrame,"sliderTextG",160,pY,0,1,1,"Coordinates font color Green (G)",160,"sliderGChangeHandler");
      pY = pY - pInc;
      sliderTextB = createSlider(DCoordsMenuFrame,"sliderTextB",160,pY,0,1,1,"Coordinates font color Blue (B)",160,"sliderBChangeHandler");
      pY = pY - pInc;
      sliderTextA = createSlider(DCoordsMenuFrame,"sliderTextA",160,pY,0,1,1,"Coordinates font Alpha (A)",160,"sliderAChangeHandler");
      pY = pY - pInc;
      sliderMainFontSize = createSlider(DCoordsMenuFrame,"sliderMainFontSize",160,pY,8,100,DCoords_MainFrameFontSize,"Coordinates font size",160,"sliderMainFontSizeChangeHandler");
      
      pY = pY - pInc;
      
      
      
      -- font dropdown
      dropDownFont = CreateFrame("FRAME", "DCoordsFontSelectionDropDown", DCoordsMenuFrame, "UIDropDownMenuTemplate")
	dropDownFont:SetPoint("TOPLEFT", 140, pY);
      pY = pY - pInc;
      
	UIDropDownMenu_SetWidth(dropDownFont, 148)
	UIDropDownMenu_SetText(dropDownFont, "You are using font " .. DCoords_MainFrameFont)
      UIDropDownMenu_Initialize(dropDownFont, function(self, level, menuList)
            local info = UIDropDownMenu_CreateInfo()
            info.func = self.SetDCoordsFont;
            for i=1,#fontFiles do
                  info.text, info.arg1, info.checked = "Font " .. tostring(i), i, false;
                  UIDropDownMenu_AddButton(info);
            end
            
      end)
      
	function dropDownFont:SetDCoordsFont(newValue)
		DCoords_MainFrameFont = newValue;
            UIDropDownMenu_SetText(dropDownFont, "You are using font " .. DCoords_MainFrameFont)
		updateDCoordsMainFrame();
            updateDCoordsMapFrameState();
            setDCoordsMainFrameText("Darcey@AllForTheCode.co.uk");
	end
      
      
      
      
      -- Background type     
      pY = -48;
      dropDownBgType = CreateFrame("FRAME", "DCoordsBgDropDown", DCoordsMenuFrame, "UIDropDownMenuTemplate")
	dropDownBgType:SetPoint("TOPLEFT", 350, pY)
      
	UIDropDownMenu_SetWidth(dropDownBgType, 148)
	UIDropDownMenu_SetText(dropDownBgType, "Background type " .. DCoordsBgTypes[DCoords_MainFrameSelectedBg]);
      UIDropDownMenu_Initialize(dropDownBgType, function(self, level, menuList)
            local info = UIDropDownMenu_CreateInfo()
            info.func = self.SetDCoordsMainFrameBg;
            for i=1,#DCoordsBgTypes do
                  info.text, info.arg1, info.checked = DCoordsBgTypes[i], i, false;
                  UIDropDownMenu_AddButton(info);
            end
            
      end)
      
	function dropDownBgType:SetDCoordsMainFrameBg(alignmentValue)
            log("SetAlignmentValue(): " .. alignmentValue);
            DCoords_MainFrameSelectedBg = alignmentValue;
            log("DCoordsBgTypes[DCoords_MainFrameSelectedBg] = " .. DCoordsBgTypes[DCoords_MainFrameSelectedBg]);
            UIDropDownMenu_SetText(dropDownBgType, "Background type " .. DCoordsBgTypes[DCoords_MainFrameSelectedBg]);
            updateDCoordsMainFrame();
	end
      pY = pY - pInc;
      
      
      
      sliderBgR = createSlider(
            DCoordsMenuFrame,
            "sliderBackgroundR",
            370,pY,
            0,1,1,
            "Background Red (R)",160,"sliderBgRChangeHandler");
      pY = pY - pInc;
      
      sliderBgG = createSlider(
            DCoordsMenuFrame,
            "sliderBackgroundG",
            370,pY,
            0,1,1,
            "Background Green (G)",160,"sliderBgGChangeHandler");
      pY = pY - pInc;
      
      sliderBgB = createSlider(
            DCoordsMenuFrame,
            "sliderBackgroundB",
            370,pY,
            0,1,1,
            "Background Blue (B)",160,"sliderBgBChangeHandler");
      pY = pY - pInc;
      
      sliderBgA = createSlider(
            DCoordsMenuFrame,
            "sliderBackgroundA",
            370,pY,
            0,1,1,
            "Background Alpha (A)",160,"sliderBgAChangeHandler");
      pY = pY - pInc;
      
      
      
      
      
      local pX = 580;
      pY = -48;
      sliderMapFontSize = createSlider(
            DCoordsMenuFrame,
            "sliderMapFontSize",
            pX,pY,
            8,100,DCoords_MapFrameFontSize,
            "Map font size",160,"sliderMapFontSizeChangeHandler");
      pY = pY - pInc;
      
      sliderMapFontR = createSlider(
            DCoordsMenuFrame,
            "sliderMapFontR",
            pX,pY,
            0,1,1,
            "Map font Red (R)",160,"sliderMapFontRChangeHandler");
      pY = pY - pInc;

      sliderMapFontG = createSlider(
            DCoordsMenuFrame,
            "sliderMapFontG",
            pX,pY,
            0,1,1,
            "Map font Green (G)",160,"sliderMapFontGChangeHandler");
      pY = pY - pInc;

      sliderMapFontB = createSlider(
            DCoordsMenuFrame,
            "sliderMapFontB",
            pX,pY,
            0,1,1,
            "Map font Blue (B)",160,"sliderMapFontBChangeHandler");
      pY = pY - pInc;

      sliderMapFontA = createSlider(
            DCoordsMenuFrame,
            "sliderMapFontA",
            pX,pY,
            0,1,1,
            "Map font Alpha (A)",160,"sliderMapFontAChangeHandler");
      pY = pY - pInc;      
            
      
      
      -- Alignment drop down
      --[[
      local dropDownAlignWARNING = createText(
            DCoordsMenuFrame,
            "WARNING: EXPERIMENTAL FEATURE!",
            12,
            394,pY-27
      );
      
      dropDownAlign = CreateFrame("FRAME", "DCoordsAlignDropDown", DCoordsMenuFrame, "UIDropDownMenuTemplate")
	dropDownAlign:SetPoint("TOPLEFT", 350, pY)
      
	UIDropDownMenu_SetWidth(dropDownAlign, 160)
	UIDropDownMenu_SetText(dropDownAlign, "Text align to " .. alignmentTypes[DCoords_MainFrameTextAlign]);
      UIDropDownMenu_Initialize(dropDownAlign, function(self, level, menuList)
            local info = UIDropDownMenu_CreateInfo()
            info.func = self.SetAlignmentValue;
            for i=1,#alignmentTypes do
                  info.text, info.arg1, info.checked = alignmentTypes[i], i, false;
                  UIDropDownMenu_AddButton(info);
            end
            
      end)
      
	function dropDownAlign:SetAlignmentValue(alignmentValue)
            log("SetAlignmentValue(): " .. alignmentValue);
            DCoords_MainFrameTextAlign = alignmentValue;
            log("alignmentTypes[DCoords_MainFrameTextAlign] = " .. alignmentTypes[DCoords_MainFrameTextAlign]);
            UIDropDownMenu_SetText(dropDownAlign, "Text align to " .. alignmentTypes[DCoords_MainFrameTextAlign]);
            setDCoordsMainFrameText();
	end
     --]]
      
      
      
      
      -- btnClose
      local btnClose = CreateFrame("button","btnClose", DCoordsMenuFrame, "UIPanelButtonTemplate")
      btnClose:SetHeight(20)
      btnClose:SetWidth(26)
      btnClose:SetPoint("TOPRIGHT", 2, 2)
      btnClose:SetText("X")
      btnClose:SetScript("OnClick", function(self) playClick(); self:GetParent():Hide(); end)
      
      
      -- btnReset
      local btnReset = CreateFrame("button","btnReset", DCoordsMenuFrame, "UIPanelButtonTemplate")
      btnReset:SetHeight(22)
      btnReset:SetWidth(44)
      btnReset:SetPoint("BOTTOMLEFT", 20, 140)
      btnReset:SetText("RESET")
      btnReset:SetScript("OnClick", function(self) 
            reset();
      end)
      
      
      
      
      
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
reset = function()      
      DCoords_MainFrameName = "DCoordsMainFrame";
      DCoords_MainFrameVisible = true;
      DCoords_MainFrameX = 400;
      DCoords_MainFrameY = 300;
      DCoords_MainFrameWidth = 150;
      DCoords_MainFrameHeight = 10;
      DCoords_MainFrameSelectedBg = 1;
      DCoords_MainFrameShowBg = true;
      DCoords_MainFrameBgAlpha = 1;
      DCoords_MainFrameFont = 1;
      DCoords_MainFrameFontSize = 30;
      DCoords_MainFrameTextR = 1;
      DCoords_MainFrameTextG = 1;
      DCoords_MainFrameTextB = 1;
      DCoords_MainFrameTextAlpha = 1;
      DCoords_MainFrameTextAlign = 1;

      DCoords_MapFontR = 1;
      DCoords_MapFontG = 1;
      DCoords_MapFontB = 1;
      DCoords_MapFontA = 1;

      DCoords_MainFrameBgR = 0;
      DCoords_MainFrameBgG = 0;
      DCoords_MainFrameBgB = 0;
      DCoords_MainFrameBgA = 0.5;

      DCoords_MainFrameDragEnabled = true;
      DCoords_MainFrameShowZone = true;
      DCoords_MainFrameShowSubZone = true;
      DCoords_MainFrameDecimalPrecision = 2;

      DCoords_MapFrameVisible = true;
      DCoords_MapFrameFont = 1;
      DCoords_MapFrameFontSize = 16;
      DCoords_MapFrameTextAlpha = 1;
      DCoords_MapFrameSingleDecimal = true;
      
      updateDCoordsMainFrame();
      updateDCoordsMenuFrameState();

      DCoordsMainFrame:ClearAllPoints();
      DCoordsMainFrame:SetPoint("CENTER",0,0);
      
      DCoordsMenuFrame:ClearAllPoints();
      DCoordsMenuFrame:SetPoint("CENTER",0,0);
      
      
      
      log("DCoords reset complete!");
      PlaySound("QUESTADDED");
      ReloadUI();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function updateDCoordsMenuFrameState()
      log("updateDCoordsMenuFrameState()");
      cbShowDCoords:SetChecked(DCoords_MainFrameVisible);
      cbEnableDrag:SetChecked(DCoords_MainFrameDragEnabled);
      
      cbShowZone:SetChecked(DCoords_MainFrameShowZone);
      cbShowSubZone:SetChecked(DCoords_MainFrameShowSubZone);
      cbShowBackground:SetChecked(DCoords_MainFrameShowBg);
      
      cbShowMapCoordinates:SetChecked(DCoords_MapFrameVisible);
      
      sliderDecimalPrecision:SetValue(DCoords_MainFrameDecimalPrecision);
      sliderTextR:SetValue(DCoords_MainFrameTextR);
      sliderTextG:SetValue(DCoords_MainFrameTextG);
      sliderTextB:SetValue(DCoords_MainFrameTextB);
      sliderTextA:SetValue(DCoords_MainFrameTextAlpha);
      
      sliderBgR:SetValue(DCoords_MainFrameBgR);
      sliderBgG:SetValue(DCoords_MainFrameBgG);
      sliderBgB:SetValue(DCoords_MainFrameBgB);
      sliderBgA:SetValue(DCoords_MainFrameBgA);
      
      sliderMainFontSize:SetValue(DCoords_MainFrameFontSize);
      
      

      
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- eventHandlerFunctions
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function sliderMainFontSizeChangeHandler(value)
      DCoords_MainFrameFontSize = value;
      updateDCoordsMainFrame();
end
function sliderMapFontSizeChangeHandler(value)
      log("sliderMapFontSizeChangeHandler(): " .. value);
      DCoords_MapFrameFontSize = value;
      updateDCoordsMapFrameState();
end



function sliderBgRChangeHandler(value)
      DCoords_MainFrameBgR = value;
      if (DCoords_MainFrameSelectedBg == 1 and DCoords_MainFrameShowBg == true) then
            DCoordsMainFrame.texture:SetColorTexture(DCoords_MainFrameBgR,DCoords_MainFrameBgG,DCoords_MainFrameBgB,DCoords_MainFrameBgA);
      end
end
function sliderBgGChangeHandler(value)
      DCoords_MainFrameBgG = value;
      if (DCoords_MainFrameSelectedBg == 1 and DCoords_MainFrameShowBg == true) then
            DCoordsMainFrame.texture:SetColorTexture(DCoords_MainFrameBgR,DCoords_MainFrameBgG,DCoords_MainFrameBgB,DCoords_MainFrameBgA);
      end
end
function sliderBgBChangeHandler(value)
      DCoords_MainFrameBgB = value;
      if (DCoords_MainFrameSelectedBg == 1 and DCoords_MainFrameShowBg == true) then
            DCoordsMainFrame.texture:SetColorTexture(DCoords_MainFrameBgR,DCoords_MainFrameBgG,DCoords_MainFrameBgB,DCoords_MainFrameBgA);
      end
end

function sliderBgAChangeHandler(value)
      DCoords_MainFrameBgA = value;
      if (DCoords_MainFrameSelectedBg == 1 and DCoords_MainFrameShowBg == true) then
            DCoordsMainFrame.texture:SetColorTexture(DCoords_MainFrameBgR,DCoords_MainFrameBgG,DCoords_MainFrameBgB,DCoords_MainFrameBgA);
      end
end





function sliderMapFontRChangeHandler(value)
      DCoords_MapFontR = value;
      updateDCoordsMapFrameState();
end
function sliderMapFontGChangeHandler(value)
      DCoords_MapFontG = value;
      updateDCoordsMapFrameState();
end
function sliderMapFontBChangeHandler(value)
      DCoords_MapFontB = value;
      updateDCoordsMapFrameState();
end

function sliderMapFontAChangeHandler(value)
      DCoords_MapFontA = value;
      updateDCoordsMapFrameState();
end





function sliderDecimalPrecisionChangeHandler(value)
      DCoords_MainFrameDecimalPrecision = value;
end
function sliderAChangeHandler(value)
      DCoords_MainFrameTextAlpha = value;
      DCoordsMainFrameText:SetTextColor(DCoords_MainFrameTextR,DCoords_MainFrameTextG,DCoords_MainFrameTextB,DCoords_MainFrameTextAlpha);
end
function sliderRChangeHandler(value)
      DCoords_MainFrameTextR = value;
      DCoordsMainFrameText:SetTextColor(DCoords_MainFrameTextR,DCoords_MainFrameTextG,DCoords_MainFrameTextB,DCoords_MainFrameTextAlpha);
end
function sliderGChangeHandler(value)
      DCoords_MainFrameTextG = value;
      DCoordsMainFrameText:SetTextColor(DCoords_MainFrameTextR,DCoords_MainFrameTextG,DCoords_MainFrameTextB,DCoords_MainFrameTextAlpha);
end
function sliderBChangeHandler(value)
      DCoords_MainFrameTextB = value;
      DCoordsMainFrameText:SetTextColor(DCoords_MainFrameTextR,DCoords_MainFrameTextG,DCoords_MainFrameTextB,DCoords_MainFrameTextAlpha);
end
function cbShowDCoordsHandler(checked)
      DCoords_MainFrameVisible = checked;
      updateDCoordsMainFrame();
end
function cbEnableDragHandler(checked)
      DCoords_MainFrameDragEnabled = checked;
      updateDCoordsMainFrame();
end
function cbShowZoneHandler(checked)
      DCoords_MainFrameShowZone = checked;
end
function cbShowSubZoneHandler(checked)
      DCoords_MainFrameShowSubZone = checked;
end
function cbShowBackgroundHandler(checked)
      DCoords_MainFrameShowBg = checked;
      updateDCoordsMainFrame();
end
function cbShowMapCoordinatesHandler(checked)
      DCoords_MapFrameVisible = checked;
      updateDCoordsMapFrameState();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- init/constructor
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- See DCoords.lua > DCoordsEventFrame